<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
<head>
  <meta charset="utf-8" />
  <meta name="generator" content="pandoc" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=yes" />
  <title>Cacti – Reference Plugins</title>
  <style type="text/css">
      code{white-space: pre-wrap;}
      span.smallcaps{font-variant: small-caps;}
      span.underline{text-decoration: underline;}
      div.column{display: inline-block; vertical-align: top; width: 50%;}
  </style>
  <style type="text/css">
a.sourceLine { display: inline-block; line-height: 1.25; }
a.sourceLine { pointer-events: none; color: inherit; text-decoration: inherit; }
a.sourceLine:empty { height: 1.2em; }
.sourceCode { overflow: visible; }
code.sourceCode { white-space: pre; position: relative; }
div.sourceCode { margin: 1em 0; }
pre.sourceCode { margin: 0; }
@media screen {
div.sourceCode { overflow: auto; }
}
@media print {
code.sourceCode { white-space: pre-wrap; }
a.sourceLine { text-indent: -1em; padding-left: 1em; }
}
pre.numberSource a.sourceLine
  { position: relative; left: -4em; }
pre.numberSource a.sourceLine::before
  { content: attr(title);
    position: relative; left: -1em; text-align: right; vertical-align: baseline;
    border: none; pointer-events: all; display: inline-block;
    -webkit-touch-callout: none; -webkit-user-select: none;
    -khtml-user-select: none; -moz-user-select: none;
    -ms-user-select: none; user-select: none;
    padding: 0 4px; width: 4em;
    color: #aaaaaa;
  }
pre.numberSource { margin-left: 3em; border-left: 1px solid #aaaaaa;  padding-left: 4px; }
div.sourceCode
  {  }
@media screen {
a.sourceLine::before { text-decoration: underline; }
}
code span.al { color: #ff0000; font-weight: bold; } /* Alert */
code span.an { color: #60a0b0; font-weight: bold; font-style: italic; } /* Annotation */
code span.at { color: #7d9029; } /* Attribute */
code span.bn { color: #40a070; } /* BaseN */
code span.bu { } /* BuiltIn */
code span.cf { color: #007020; font-weight: bold; } /* ControlFlow */
code span.ch { color: #4070a0; } /* Char */
code span.cn { color: #880000; } /* Constant */
code span.co { color: #60a0b0; font-style: italic; } /* Comment */
code span.cv { color: #60a0b0; font-weight: bold; font-style: italic; } /* CommentVar */
code span.do { color: #ba2121; font-style: italic; } /* Documentation */
code span.dt { color: #902000; } /* DataType */
code span.dv { color: #40a070; } /* DecVal */
code span.er { color: #ff0000; font-weight: bold; } /* Error */
code span.ex { } /* Extension */
code span.fl { color: #40a070; } /* Float */
code span.fu { color: #06287e; } /* Function */
code span.im { } /* Import */
code span.in { color: #60a0b0; font-weight: bold; font-style: italic; } /* Information */
code span.kw { color: #007020; font-weight: bold; } /* Keyword */
code span.op { color: #666666; } /* Operator */
code span.ot { color: #007020; } /* Other */
code span.pp { color: #bc7a00; } /* Preprocessor */
code span.sc { color: #4070a0; } /* SpecialChar */
code span.ss { color: #bb6688; } /* SpecialString */
code span.st { color: #4070a0; } /* String */
code span.va { color: #19177c; } /* Variable */
code span.vs { color: #4070a0; } /* VerbatimString */
code span.wa { color: #60a0b0; font-weight: bold; font-style: italic; } /* Warning */
  </style>
  <link rel="stylesheet" href="Cacti-Github.css" />
</head>
<body>
<h1 id="reference-plugins">Reference Plugins</h1>
<p>FIXME The reference plugin is under development. Nothing to see here yet.</p>
<p>The Reference Plugin(s) are generic plugins that implement key pieces of the Plugin Architecture.</p>
<p>They are broken down into several separate plugins, each covering different portions of the <a href="Plugin-Hook-API-Ref.html">Hook API Reference</a></p>
<h2 id="standard-files">Standard Files</h2>
<p>The following files should be included in every plugin</p>
<ul>
<li>CHANGELOG</li>
<li>INFO</li>
<li>LICENSE</li>
<li>index.php</li>
<li>README.md</li>
<li>setup.php</li>
</ul>
<p>In general, the index.php file example below should be included in every plugin directory as it prevents remote file browsing of your Cacti site.</p>
<div class="sourceCode" id="cb1"><pre class="sourceCode php"><code class="sourceCode php"><a class="sourceLine" id="cb1-1" title="1"><span class="kw">&lt;?php</span></a>
<a class="sourceLine" id="cb1-2" title="2"></a>
<a class="sourceLine" id="cb1-3" title="3"><span class="co">/*</span></a>
<a class="sourceLine" id="cb1-4" title="4"><span class="co"> +-------------------------------------------------------------------------+</span></a>
<a class="sourceLine" id="cb1-5" title="5"><span class="co"> | Copyright (C) 2004-2021 The Cacti Group                                 |</span></a>
<a class="sourceLine" id="cb1-6" title="6"><span class="co"> |                                                                         |</span></a>
<a class="sourceLine" id="cb1-7" title="7"><span class="co"> | This program is free software; you can redistribute it and/or           |</span></a>
<a class="sourceLine" id="cb1-8" title="8"><span class="co"> | modify it under the terms of the GNU General Public License             |</span></a>
<a class="sourceLine" id="cb1-9" title="9"><span class="co"> | as published by the Free Software Foundation; either version 2          |</span></a>
<a class="sourceLine" id="cb1-10" title="10"><span class="co"> | of the License, or (at your option) any later version.                  |</span></a>
<a class="sourceLine" id="cb1-11" title="11"><span class="co"> |                                                                         |</span></a>
<a class="sourceLine" id="cb1-12" title="12"><span class="co"> | This program is distributed in the hope that it will be useful,         |</span></a>
<a class="sourceLine" id="cb1-13" title="13"><span class="co"> | but WITHOUT ANY WARRANTY; without even the implied warranty of          |</span></a>
<a class="sourceLine" id="cb1-14" title="14"><span class="co"> | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           |</span></a>
<a class="sourceLine" id="cb1-15" title="15"><span class="co"> | GNU General Public License for more details.                            |</span></a>
<a class="sourceLine" id="cb1-16" title="16"><span class="co"> +-------------------------------------------------------------------------+</span></a>
<a class="sourceLine" id="cb1-17" title="17"><span class="co"> | Cacti: The Complete RRDtool-based Graphing Solution                     |</span></a>
<a class="sourceLine" id="cb1-18" title="18"><span class="co"> +-------------------------------------------------------------------------+</span></a>
<a class="sourceLine" id="cb1-19" title="19"><span class="co"> | This code is designed, written, and maintained by the Cacti Group. See  |</span></a>
<a class="sourceLine" id="cb1-20" title="20"><span class="co"> | about.php and/or the AUTHORS file for specific developer information.   |</span></a>
<a class="sourceLine" id="cb1-21" title="21"><span class="co"> +-------------------------------------------------------------------------+</span></a>
<a class="sourceLine" id="cb1-22" title="22"><span class="co"> | https://www.cacti.net/                                                   |</span></a>
<a class="sourceLine" id="cb1-23" title="23"><span class="co"> +-------------------------------------------------------------------------+</span></a>
<a class="sourceLine" id="cb1-24" title="24"><span class="co">*/</span></a>
<a class="sourceLine" id="cb1-25" title="25"></a>
<a class="sourceLine" id="cb1-26" title="26"><span class="fu">header</span><span class="ot">(</span><span class="st">&quot;Location:../index.php&quot;</span><span class="ot">);</span></a>
<a class="sourceLine" id="cb1-27" title="27"></a>
<a class="sourceLine" id="cb1-28" title="28"><span class="kw">?&gt;</span></a></code></pre></div>
<h2 id="file-structure">File Structure</h2>
<p>All plugin files should reside under their own respective plugin directory. The example below is for a plugin called 'myplugin'.</p>
<pre class="console"><code>myplugin/
    images/
        myimage.png
        index.php
    lib/
        index.php
        functions.php
    include/
        index.php
        settings.php
    CHANGELOG
    INFO
    LICENSE
    README.md
    index.php
    setup.php
</code></pre>
<h2 id="contents-of-files">Contents of Files</h2>
<p>The four core sub-directories included in your plugin should be docs, images, lib, and include. As previously mentioned, each of these directories should include an index.php that points to it's parent directory index.php. This way we prevent people from randomly browsing the contents of our web site.</p>
<p>The two main files required for every plugin are the INFO and the setup.php file. Without these two files, the plugin directory will not be recognized as a valid plugin and will be skipped.</p>
<p>The INFO file is formatted as Microsoft standard INI file. It contains information about the plugin including its version, author, dependencies, functions, and minimum version of Cacti and other plugins required. Below, you can see a reference INFO file for the myplugin plugin.</p>
<pre class="console"><code>[info]
name = mplugin
version = 1.0
longname = My First Plugin
author = Depeche Mode
email = somewhere@outthere.com
homepage = http://www.outthere.com
compat = 1.2
requires = thold monitor
capabilities = online_view:1, online_mgmt:1, offline_view:0, offline_mgmt:0, remote_collect:0
</code></pre>
<p>The setup file includes key plugin functions that allow the plugin to be installed, uninstalled, upgraded, etc. Those core functions include:</p>
<div class="sourceCode" id="cb4"><pre class="sourceCode php"><code class="sourceCode php"><a class="sourceLine" id="cb4-1" title="1"><span class="kw">&lt;?php</span></a>
<a class="sourceLine" id="cb4-2" title="2"><span class="kw">function</span> plugin_myplugin_install<span class="ot">()</span> {</a>
<a class="sourceLine" id="cb4-3" title="3">}</a>
<a class="sourceLine" id="cb4-4" title="4"></a>
<a class="sourceLine" id="cb4-5" title="5"><span class="kw">function</span> plugin_myplugin_uninstall<span class="ot">()</span> {</a>
<a class="sourceLine" id="cb4-6" title="6">}</a>
<a class="sourceLine" id="cb4-7" title="7"></a>
<a class="sourceLine" id="cb4-8" title="8"><span class="kw">function</span> plugin_myplugin_check_config<span class="ot">()</span> {</a>
<a class="sourceLine" id="cb4-9" title="9">}</a>
<a class="sourceLine" id="cb4-10" title="10"></a>
<a class="sourceLine" id="cb4-11" title="11"><span class="kw">function</span> plugin_myplugin_upgrade<span class="ot">()</span> {</a>
<a class="sourceLine" id="cb4-12" title="12">}</a>
<a class="sourceLine" id="cb4-13" title="13"></a>
<a class="sourceLine" id="cb4-14" title="14"><span class="kw">function</span> plugin_myplugin_version<span class="ot">()</span> {</a>
<a class="sourceLine" id="cb4-15" title="15">}</a>
<a class="sourceLine" id="cb4-16" title="16"></a>
<a class="sourceLine" id="cb4-17" title="17"><span class="kw">?&gt;</span></a></code></pre></div>
<p>Without these core functions, in your setup.php, your plugin will not fully operate. We will document those functions and what they should include as we continue to document the plugin design principals.</p>
<p>Any core plugin functions should always be placed in the lib/functions.php file, and settings should go into the include/settings.php file. The plugin architecture allows hooks to be defined that reach into the include/settings.php file. Having those hooks point to the include version of the file will keep Cacti page loads fast. Including too much in the setup.php slows Cacti and should be avoided.</p>
<hr />
<p><copy>Copyright (c) 2004-2021 The Cacti Group</copy></p>
</body>
</html>
